#!/usr/bin/bash

display=$1
port=$2
resolution=$3
idle=$4

# display    = X display number
# port       = VNC listen port
# resolution = WxHxD (Width x Height x color_Depth) e.g. 1440x960x24
# idle       = Lock screen after idle minutes

sleep=5 # wait Xvfb totally initialized before running openbox

export DISPLAY=:${display}

pids=~/.Xvfb_vnc/pids
mkdir -p ${pids}
Xvfb :${display} -ac -screen 0 ${resolution} &
echo $! > ${pids}/Xvfb-${display}.pid
sleep ${sleep} 
openbox-session &
echo $! > ${pids}/openbox-${display}.pid
xautolock -time ${idle} -locker slock &
echo $! > ${pids}/xautolock-${display}.pid
x11vnc -repeat -ncache -usepw -reopen -forever -display :${display} -rfbport ${port} &
pid=$!
echo $pid > ${pids}/x11vnc-${display}.pid
wait $pid
